<?php

/**
 * Access plugin that provides callback-function-based access control.
 */
class views_access_callback_plugin_access_callback extends views_plugin_access {

  function access($account) {
    return views_access_callback_access_callback($this->options['views_access_callbacks'], array($this->view->name, $this->display->id, $this->options['views_access_callback']));
  }

  function get_access_callback() {
    return array('views_access_callback_access_callback', array($this->view->name, $this->display->id, $this->options['views_access_callback']));
  }

  function summary_title() {
    return t('Callback function') . ': ' . $this->options['views_access_callback'];
  }

  function option_defaults(&$options) {
    $options['views_access_callback'] = '';
  }

  function options_form(&$form, &$form_state) {
    $callbacks = array();
    // Get list of callbacks
    foreach (module_list(FALSE, FALSE, TRUE) as $module) {
      if ($module_callbacks = module_invoke($module, 'views_access_callbacks')) {
        $callbacks[$module] = drupal_map_assoc($module_callbacks);
      }
    }
    $form['views_access_callback'] = array(
      '#type' => 'select',
      '#options' => $callbacks,
      '#title' => t('Callbacks'),
      '#default_value' => $this->options['views_access_callback'],
      '#description' => t('Only users for which selected callback function returns TRUE will be able to access this display.<br />Note that users with "access all views" can see any view, regardless of other permissions.'),
    );
  }
}
